<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit();
}
class VIWCAIO_CART_ALL_IN_ONE_Frontend_Form_Checkout {
	public function __construct() {
		add_action( 'vi_wcaio_checkout_step_order_review', array( __CLASS__, 'viwcaio_checkout_step_order_review' ) );
		add_action( 'vi_wcaio_checkout_step_payment', array( __CLASS__, 'viwcaio_checkout_step_payment' ) );
		add_action( 'vi_wcaio_checkout_order_review', 'woocommerce_order_review'  );
		add_action( 'vi_wcaio_checkout_payment',  'woocommerce_checkout_payment'  );
		add_action( 'vi_wcaio_checkout_step_billing', array( __CLASS__, 'viwcaio_checkout_step_billing' ) );
		add_action( 'vi_wcaio_checkout_step_shipping', array( __CLASS__, 'viwcaio_checkout_step_shipping' ) );
	}
	public static function viwcaio_checkout_step_billing(){
		do_action( 'woocommerce_checkout_before_customer_details' );
		do_action( 'woocommerce_checkout_billing' );
	}
	public static function viwcaio_checkout_step_shipping(){
		do_action( 'woocommerce_checkout_shipping' );
		do_action( 'woocommerce_checkout_after_customer_details' );
	}
	public static function viwcaio_checkout_step_order_review(){
		do_action( 'woocommerce_checkout_before_order_review_heading' );
		do_action( 'woocommerce_checkout_before_order_review' );
		echo sprintf('<div id="order_review" class="woocommerce-checkout-review-order">');
		do_action( 'woocommerce_checkout_order_review' );
		do_action( 'vi_wcaio_checkout_order_review' );
		echo sprintf('</div>');
	}
	public static function viwcaio_checkout_step_order_review_germanized(){
		do_action( 'woocommerce_checkout_before_order_review_heading' );
		do_action( 'woocommerce_checkout_before_order_review' );
		echo sprintf('<div id="order_review" class="woocommerce-checkout-review-order">');
		do_action( 'vi_wcaio_checkout_order_review' );
		if (is_ajax() && function_exists( 'woocommerce_gzd_template_order_submit' ) ) {
			woocommerce_gzd_template_order_submit();
		}
		echo sprintf('</div>');
	}
	public static function viwcaio_checkout_step_payment(){
		do_action( 'vi_wcaio_checkout_payment' );
		do_action( 'woocommerce_checkout_after_order_review' );
	}
	public static function viwcaio_is_not_checkout($result){
		return apply_filters('viwcaio_is_not_checkout', false);
	}
	public static function viwcaio_is_checkout($result){
		return apply_filters('viwcaio_is_checkout', true);
	}
	public static function viwcaio_wc_square_credit_card_payment_form_js_args($args, $payment){
		wc_enqueue_js( sprintf( 'window.viwcaio_wc_%s_payment_form_handler = %s ;', esc_js( $payment->get_gateway()->get_id() ), json_encode( $args ) ) );
		return $args;
	}
	public static function viwcaio_woocommerce_update_order_review_fragments($fragments){
		if (!empty($_REQUEST['viwcaio_need_shipping']) && WC()->cart->needs_shipping_address()){
			ob_start();
			do_action('vi_wcaio_checkout_step_shipping');
			$shipping = ob_get_clean();
			$fragments['.vi-wcaio-checkout-shipping']= '<div class="vi-wcaio-checkout-shipping vi-wcaio-checkout-shipping-replace">'.$shipping.'</div>';
		}
		return $fragments;
	}
}